
#include <stdio.h>
#include <stdlib.h>
#include "sif_r.h"

extern void	Error(char *msg),
		RangeList(char *string,size_t limit,char *on_off);

#define LEN	2048

int	main(int argc,char **argv)
{
	FILE	*file;
	int	Nx,Ny,y,z,x,Nz=1;
	char	str[LEN],*RL,*bde="binary data %s error at %d.";
	size_t	size;
	double	**BD,min,max,bd;
	FOM	*fom;

	if (argc!=4) Error("usage : bin2raw file.bin rangeList RAW_format");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fgets(str,LEN,file)==NULL ||
	    sscanf(str,"%d %d %d",&Nx,&Ny,&Nz)<2 ||
	    Nx<=0 || Ny<=0 || Nz<=0) Error("bad binary data size.");

	size=sizeof(double)*Nx*Ny;

	if ((RL=(char *)malloc(sizeof(char)*Nz))==NULL ||
	    (BD=(double **)malloc(sizeof(double *)*Ny))==NULL ||
	    (*BD=(double *)malloc(size))==NULL)
	    Error("memory allocation error.");

	RangeList(argv[2],Nz,RL);

	for (y=1; y<Ny; y++) BD[y]=BD[y-1]+Nx;

	for (z=0; z<Nz; z++)
	    if (RL[z]) {
		if (fread(*BD,size,1,file)!=1) {
		    (void)sprintf(str,bde,"read",z); Error(str);
		}
		min=max=BD[0][0];
		for (y=0; y<Ny; y++) {
		    fom=(FOM *)BD[y];
		    for (x=0; x<Nx; x++) {
			fom[x]=bd=BD[y][x]; if (bd<min) min=bd; else
					    if (bd>max) max=bd;
		    }
		}
		(void)printf("%d\t%lf\t%lf\n",z,min,max);

		(void)sprintf(str,argv[3],z);
		StoreImageFile_Raw(str,Nx,Ny,min,max,(FOM **)BD);
	    }
	    else {
		if (file==stdin) {
		    if (fread(*BD,size,1,file)==1) continue;
		}
		else
		    if (!fseeko(file,(off_t)size,SEEK_CUR)) continue;

		(void)sprintf(str,bde,"skip",z); Error(str);
	    }

	free(*BD); free(BD); free(RL);

	if (file!=stdin) (void)fclose(file);

	return 0;
}
