
#include <stdio.h>
#include <stdlib.h>

static void	Error(char *msg)
{
	(void)fputs(msg,stderr); (void)fputc('\n',stderr); exit(1);
}

#define ULL	unsigned long long

int	main(int argc,char **argv)
{
	FILE		*file;
	char		H[64];
	unsigned	bits,u,
			*NI=(unsigned *)(H+14),	/* number of images */
			ni=0,
			images=0;
	short		*CL=(short *)(H+2),	/* comment length */
			*IW=(short *)(H+4),	/* image width */
			*IH=(short *)(H+6),	/* image height */
			*FT=(short *)(H+12),	/* file type */
			*RC=(short *)(H+18),	/* remaining channels */
			rc=1;
	ULL		size=0;

	if (argc!=2) Error("usage : check_his_cl HIS_file");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	while (!feof(file) && (ni!=0 || rc!=0)) {
	    if (fread(&H,64,1,file)!=1 ||
		H[0]!='I' || H[1]!='M') Error("header read error.");

	    if (*CL!=0)
	    (void)printf("%u\t%hd\t%hd\t%hd\t%hd\n",images++,*CL,*IW,*IH,*FT);

	    switch(*FT) {
		case  1: bits= 8; break; case 11: bits=24; break;
		case  2: bits=16; break; case 12: bits=48; break;
		case  3: bits=32; break; case 13: bits=96; break;
		case  6: bits=12; break; case 14: bits=36; break;
		default: Error("unkonown file type.");
	    }
	    size+=(64+(u=(*CL)+(unsigned)(((ULL)*IW*(*IH)*bits+7)/8)));
	    if (file!=stdin)
		(void)fseeko(file,(off_t)u,SEEK_CUR);
	    else
		do (void)fgetc(file); while (--u!=0);

	    if (ni==0) {
		ni=(*NI); rc=(*RC);
	    }
	    --ni;
	}
	(void)fprintf(stderr,"%u\t%llu\n",images,size);

	if (file!=stdin) (void)fclose(file);

	return 0;
}
