
#include <stdio.h>
#include <stdlib.h>
#include "csi_f.h"
#include "rif_r.h"
#include "sif_r.h"

extern void	Error(char *msg);

#define LEN	2048

int	main(int argc,char **argv)
{
	char	**paths,path[LEN];
	int	Nx,Nz,z,name,Ny,y,x;
	double	*line,d,min,max,Dr=2.0;
	FOM	**F,*f;

	if (argc!=4 && argc!=5) Error("usage : dpc2xp DPC/ nameFile {Dr} XP/");

	paths=CheckSliceImages_Float(argv[1],argv[2],&Nx,NULL,&Nz,NULL);

	if ((line=(double *)malloc(sizeof(double)*Nx))==NULL)
	    Error("memory allocation error.");

	if (argc==5) Dr=atof(argv[3])*2.0;

	name=0; while (argv[1][name++]!='\0') ;

	for (z=0; z<Nz; z++) {
	    ReadImageFile_Raw(paths[z],&Nx,&Ny,&F);

	    for (y=0; y<Ny; y++) {
		f=F[y];
/*
		if (Nx&1)
		    line[x=Nx-1]=0.0;
		else
*/
		line[x=Nx-2]=(-f[Nx-1]);
		while ((x-=2)>=0) line[x]=line[x+2]-f[x+1];
/**/
		if (Nx&1)
		    line[x=0]=0.0;
		else
/**/
		line[x=1]=f[0];
		while ((x+=2)<Nx) line[x]=line[x-2]+f[x-1];

		for (x=0; x<Nx; x++) {
		    f[x]=d=line[x]*Dr;

		    if (x==0 && y==0) min=max=d; else if (min>d) min=d;
						 else if (max<d) max=d;
		}
	    }
	    (void)printf("%d\t%lf\t%lf\n",z,min,max);

	    (void)sprintf(path,"%s/%s",argv[argc-1],paths[z]+name);
	    StoreImageFile_Raw(path,Nx,Ny,min,max,F);

	    for (y=Ny-1; y>=0; y--) free(F[y]); free(F); free(paths[z]);
	}
	free(line); free(paths);

	return 0;
}
