#!/bin/csh
# usage : his2rp.csh HIS_file scans view darks x_RAW {x_RAW ...} RP_format
#
#set tmp=/tmp/his2rp.$$
set tmp=/dev/shm/his2rp.$$
#
alias STDERR 'echo echo 1\>\&2 "\!*" | /bin/sh'
#
if ($#argv < 6) then
  STDERR \
  usage : his2rp.csh HIS_file scans view darks x_RAW \{x_RAW ...\} RP_format
  exit 1
endif
#
set rl=
foreach x (`echo $argv[5-] | rev | cut -d' ' -f2- | rev`)
  if ($x < 0 || `expr $x + 1` >= $argv[2]) then
    STDERR $x : bad x-position on RAW image \(warning\).
  else
    set rl=($rl `expr $argv[4] + $argv[3] \* $argv[2] + 1 + $x`)
    if ($status) exit 1
  endif
end
if ("$rl" == '') exit 1
#
mkdir ${tmp}.dir
his2tiff $argv[1] `expr 1 - $argv[4]` ${tmp}.dir/%d
if ($status) then
  rm -rf ${tmp}.dir ; exit 1
endif
#
set add=(`ls ${tmp}.dir/* | sed 's/$/ 0 1 0 0/g' | add_2d 0 16 ${tmp}.tif`)
if ($status) then
  rm -rf ${tmp}.dir ; exit 1
endif
rm -rf ${tmp}.dir
#
his2tiff $argv[1] `echo $rl | tr ' ' ,` $argv[$#argv]
#
foreach his ($rl)
  set rp=`printf ${argv[$#argv]}\\n $his`
  if (-e $rp) then
    set sub=(`sub_2d $rp 0 1 ${tmp}.tif $add[3-4] 0 0 16 $rp`)
    if ($status) then
      rm -f $rp 
    else
      echo $his $sub | tr ' ' \\t
    endif
  endif
end
rm -f ${tmp}.tif
