#!/bin/csh
# usage : pile_[h,v].csh test/|word/|byte/ base step images cols rows pile.tif
#
set ratio=(0.075 0.0625 0.0125) # LU- and RD-labels, and space between images
#
#set tmp=/tmp/pile.$$
set tmp=/dev/shm/pile.$$
#
alias STDERR 'echo echo 1\>\&2 "\!*" | /bin/sh'
#
set csh=`basename $0`
switch($csh)
  case pile_h.csh :
    set h_v=- ; breaksw
  case pile_v.csh :
    set h_v= ; breaksw
  default :
    STDERR $csh : unknown C-shell script. ; exit 1
endsw
#
if ($#argv != 7) then
  STDERR usage : $csh test/\|word/\|byte/ base step images cols rows pile.tif
  exit 1
endif
#
set twb=$argv[1]
if (!(-d $twb)) then
  STDERR $twb : directory not found. ; exit 1
endif
#
set work=(`( echo $ratio ; echo $argv ; ls $twb ) | \
           awk 'NR==1 { LU=$1; RD=$2; II=$3 } \
                NR==2 { D=$1; B=$2; S=$3; I=($4<(i=$5*$6))?$4:i } \
                NR>=3 && (i=NR-3-B)>=0 && i%S==0 && i/S<I { \
                  (p="pig " (f=D "/" (t=$0))) | getline; close(p); \
                  if (NF<4) exit 1; \
                  if ($3!=1 || $4>16) { \
                    print f,": bad image type." > "/dev/stderr"; exit 1 } \
                  T[C++]=t; if (C==1 || X>$1) X=$1; \
                            if (C==1 || Y>$2) Y=$2; if (Z<$4) Z=$4 } \
                END { print LU*Y,RD*X,int(II*(X+Y)+1),2^Z-1; \
                      for (c=0; c<C; c++) print T[c] }'`)
if ($status || $#work <= 4) exit 1
#
mkdir $tmp
foreach tiff ($work[5-])
  set ctv=(`( pid ${twb}/$tiff | tr \\n ' ' ; echo ) | \
            awk -v PV=$work[4] 'NF==3 { print $2,$3*PV } \
                                NF==2 || NF==4 { print $1,$2 } \
                                NF==6 || NF==8 { print $5,$6 }'`)
  echo $tiff $ctv | tr ' ' \\t
#
  /bin/cp ${twb}/$tiff $tmp
  ( echo Helvetica $work[1] $work[4] LU `echo $tiff | sed s/\\.tif\$//g` ; \
    echo Helvetica $work[2] $work[4] RD "`echo $ctv | sed 's/ / ~ /g'`" ) | \
  add_label ${tmp}/$tiff
end
pile_gray ${h_v}$argv[5-6] -$work[3] -$work[3-4] $argv[7] ${tmp}/* ; rm -rf $tmp
