
#include <stdio.h>
#include <stdlib.h>
#include "csi_f.h"
#include "rif_r.h"

extern void	Error(char *msg);

int	main(int argc,char **argv)
{
	char	**paths;
	int	Nx,Ny,Nz,z,nx,ny,y,x;
	FILE	*file;
	FOM	**fom;
	double	d;

	if (argc!=4) Error("usage : raw2bin RAW/ nameFile file.bin");

	paths=CheckSliceImages_Float(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

	if (argv[3][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[3],"wb"))==NULL) Error("file not open.");

	(void)fprintf(file,"%d\t%d\t%d\n",Nx,Ny,Nz);

	for (z=0; z<Nz; z++) {
	    ReadImageFile_Raw(paths[z],&nx,&ny,&fom);

	    for (y=0; y<ny; y++) {
		for (x=0; x<nx; x++) {
		    d=fom[y][x]; (void)fwrite(&d,sizeof(double),1,file);
		}
		for (d=0.0; x<Nx; x++) (void)fwrite(&d,sizeof(double),1,file);

		free(fom[y]);
	    }
	    for (d=0.0; y<Ny; y++)
		for (x=0; x<Nx; x++) (void)fwrite(&d,sizeof(double),1,file);

	    free(fom); free(paths[z]);
	}
	if (file!=stdout) (void)fclose(file);

	free(paths);

	return 0;
}
