
#include <stdio.h>
#include <stdlib.h>
#include "csi_f.h"
#include "rif_r.h"
#include "cell.h"
#include "sif.h"

extern void	Error(char *msg);

#define LEN	2048

int	main(int argc,char **argv)
{
	char	**paths,range[LEN],path[LEN];
	int	Nz,bps,name,z,Nx,Ny,y,x;
	Cell	C,*cell;
	double	base,step,roof,min,max;
	FOM	**fom;

	if (argc!=5 && argc!=7)
	    Error("usage : raw2tiff RAW/ nameFile {base step} BPS TIFF/");

	paths=CheckSliceImages_Float(argv[1],argv[2],NULL,NULL,&Nz,NULL);

	if ((bps=atoi(argv[argc-2]))<=0 || bps>sizeof(Cell)*8)
	    Error("bad BPS (bits per sample).");

	C=(Cell)((1ULL<<bps)-1);

	if (argc==7) {
	    base=atof(argv[3]);
	    if ((step=atof(argv[4]))<=0.0) Error("bad pixel value step.");

	    (void)sprintf(range,"%lf\t%lf",base,roof=base+step*(double)C);
	}
	name=0; while (argv[1][name++]!='\0') ;

	for (z=0; z<Nz; z++) {
	    ReadImageFile_Raw(paths[z],&Nx,&Ny,&fom);

	    min=max=fom[0][0];
	    for (y=0; y<Ny; y++)
	    for (x=0; x<Nx; x++)
		if (min>fom[y][x]) min=fom[y][x]; else
		if (max<fom[y][x]) max=fom[y][x];

	    (void)printf("%d\t%lf\t%lf\n",z,min,max);

	    if (argc==5) {
		base=min; step=(max<=min)?1.0:(max-min)/(double)C;
		roof=max; (void)sprintf(range,"%lf\t%lf",min,max);
	    }
	    for (y=0; y<Ny; y++) {
		cell=(Cell *)fom[y];
		for (x=0; x<Nx; x++)
		    cell[x]=(fom[y][x]<base)?0:
			    (fom[y][x]>roof)?C:
			    (Cell)((fom[y][x]-base)/step+0.5);
	    }
	    (void)sprintf(path,"%s/%s",argv[argc-1],paths[z]+name);
	    StoreImageFile(path,Nx,Ny,bps,(Cell **)fom,range);

	    for (y=Ny-1; y>=0; y--) free(fom[y]); free(fom); free(paths[z]);
	}
	free(paths);

	return 0;
}
