
#include "ri2xp.h"

#ifdef	XT
#define DIV_LN(I0,I)	(I/(I0))
#else
#include <math.h>

#define DIV_LN(I0,I)	((I>0.0)?log((I0)/I):0.0)
#endif

static double	Mean(unsigned x1,unsigned x2,FOM *fom)
{
	unsigned	x;
	double		sum=0.0;

	for (x=x1; x<x2; x++) if (fom[x]>0.0) sum+=fom[x];

	return sum/(double)(x2-x1);
}

void	RI2XP(int Nx,int Ny,FOM **fom,unsigned l,unsigned r)
{
	double	m,mL,mR,xL,xR,xRL,mRL;
	int	y,x;

	if (l!=0 || r!=0)
	    if ((unsigned long long)l+(unsigned long long)r>=Nx)
		for (y=0; y<Ny; y++)
		    if ((m=Mean(0,Nx,fom[y]))>0.0)
			for (x=0; x<Nx; x++) fom[y][x]=DIV_LN(m,fom[y][x]);
		    else
			for (x=0; x<Nx; x++) fom[y][x]=0.0;
	    else
		for (y=0; y<Ny; y++) {
		    mL=Mean(0,l,fom[y]);
		    mR=Mean(Nx-r,Nx,fom[y]);
		    if (mL>0.0 && mR>0.0) {
/*
			m[x]=mL+(mR-mL)*(x-xL)/(xR-xL)
			    =(mL*(xR-x)+mR*(x-xL))/(xR-xL)
			    =(mL*xR-mR*xL+(mR-mL)*x)/(xR-xL)
*/
			xL=(double)(l-1)/2.0;
			xR=(double)Nx-(double)(r+1)/2.0;
			xRL=xR-xL; mRL=(mR/=xRL)-(mL/=xRL);
			for (m=mL*xR-mR*xL, x=0; x<Nx; x++, m+=mRL)
			    fom[y][x]=(m>0.0)?DIV_LN(m,fom[y][x]):0.0;
		    }
		    else if (mL>0.0)
			for (x=0; x<Nx; x++) fom[y][x]=DIV_LN(mL,fom[y][x]);
		    else if (mR>0.0)
			for (x=0; x<Nx; x++) fom[y][x]=DIV_LN(mR,fom[y][x]);
		    else
			for (x=0; x<Nx; x++) fom[y][x]=0.0;
		}
}
