
#include <stdio.h>
#include <stdlib.h>
#include "csi_f.h"
#include "vlr.h"
#include "rif_r.h"

#ifdef	DPC
#include "rr2dpc.h"

#define EPS	1e-9
#else
#include "ri2xp.h"
#endif

extern void	Error(char *msg);

int	main(int argc,char **argv)
{
	char	**paths;
	int	Nx,Ny,Nz,nz,z,nx,ny,y,x;
	VLR	*vlr;
	FILE	*file;
	FOM	**fom;
	double	d;
#ifdef	DPC
	double	sdd,Dp,sign;

	if (argc!=7)
	Error("usage : rr2dpc_bin RR/ nameFile VLR_file SDD {-}Dp DPC.bin");
#else
	if (argc!=5)
	    Error(
#ifdef	XT
		  "usage : ri2xt_bin RI/ nameFile VLR_file XT.bin"
#else
		  "usage : ri2xp_bin RI/ nameFile VLR_file XP.bin"
#endif
		 );
#endif
	paths=CheckSliceImages_Float(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

	vlr=ViewRangeListWithLeftAndRightMargin(Nz,argv[3]);

	if (argv[argc-1][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[argc-1],"wb"))==NULL) Error("file not open.");

	nz=0; for (z=0; z<Nz; z++) nz+=vlr[z].view;
	(void)fprintf(file,"%d\t%d\t%d\n",Nx,Ny,nz);

#ifdef	DPC
	if ((sdd=atof(argv[4]))<EPS) Error("bad sample-detector distance.");

	if ((Dp=atof(argv[5]))>=(-EPS) && Dp<=EPS)
	    Error("bad interval of detectors on refraction profile.");

	sign=Dp/sdd;
#endif
	for (z=0; z<Nz; z++) {
	    if (vlr[z].view) {
		ReadImageFile_Raw(paths[z],&nx,&ny,&fom);
#ifdef	DPC
		RR2DPC(nx,ny,fom,vlr[z].left,vlr[z].right,sign);
#else
		RI2XP(nx,ny,fom,vlr[z].left,vlr[z].right);
#endif
		for (y=0; y<ny; y++) {
		    for (x=0; x<nx; x++) {
			d=fom[y][x]; (void)fwrite(&d,sizeof(double),1,file);
		    }
		    for (d=0.0; x<Nx; x++)
			(void)fwrite(&d,sizeof(double),1,file);

		    free(fom[y]);
		}
		for (d=0.0; y<Ny; y++)
		    for (x=0; x<Nx; x++)
			(void)fwrite(&d,sizeof(double),1,file);

		free(fom);
	    }
	    free(paths[z]);
	}
	if (file!=stdout) (void)fclose(file);

	free(vlr); free(paths);

	return 0;
}
