#!/bin/csh
alias STDERR 'echo echo "\!*" 1\>\&2 | /bin/sh'
#
set csh=`basename $0`
switch($csh)
  case rp+ri.csh:
    alias RIR 'his2raw_B \!:1-5 /dev/null >/dev/null' ; @ pv = 255 ; breaksw
  case rp+rr.csh:
    alias RIR 'his2raw_B \!:1-4 /dev/null \!:5 >/dev/null' ; @ pv = 0 ; breaksw
  default:
    STDERR $csh : unknown C-shell script. ; exit 1
endsw
#
@ gap = 8
#
set tmp=/dev/shm/${csh}.$$
#
if ($#argv != 6) then
  STDERR usage : $csh log\&HIS view first increment last GIF ; exit 1
endif
#
set a=`echo $argv[1] | sed -e s/\\.log\$//g -e s/\\.HIS\$//g`
foreach file (${a}.log ${a}.HIS)
  if (!(-e $file)) then
    STDERR $file : file not found. ; exit 1
  endif
end
#
set svd=(`head -1 ${a}.log | tr , ' '`)
#
@ view = $argv[2]
if ($view < 0 || $view >= $svd[2]) then
  STDERR $view : bad view number. ; exit 1
endif
#
set sfil=($argv[3-5])
if (`echo $sfil $svd | awk '{ print ($1<0 || $2<1 || $3<$1 || $3>$4-2) }'`) then
  STDERR $sfil : bad scan number. ; exit 1
endif
#
mkdir ${tmp}.0
his2tiff ${a}.HIS -`expr $svd[3] - 1` ${tmp}.0/%d
if ($status) then
  rm -r ${tmp}.0 ; exit 1
endif
#
( chdir ${tmp}.0 ; ls | add_float 0 ${tmp}.1 >& /dev/null ) ; rm -r ${tmp}.0
#
@ i = ( $svd[1] * $view ) + ( $svd[3] + 1 )
#
mkdir ${tmp}.0
his2tiff ${a}.HIS `seq $sfil | awk -v I=$i '{ printf ",%d",I+$1 }'` ${tmp}.0/%d
if ($status) then
  rm -r ${tmp}.[0-1] ; exit 1
endif
#
( chdir ${tmp}.0 ; ls | xargs -i@ sub_float @ ${tmp}.1 0 0 @ >& /dev/null )
rm ${tmp}.1
#
t2t_float ${tmp}.0 - 8 ${tmp}.0 >/dev/null
#
RIR ${a}.HIS $svd[1] $view $svd[3] ${tmp}.1
if ($status) then
  rm -rf ${tmp}.[0-1] ; exit 1
endif
#
set nxy=(`pig ${tmp}.1`)
@ offset = $nxy[1] + $gap
echo | paste_gray 1 $nxy[2] $pv ${tmp}.2
foreach rp (`ls ${tmp}.0 | sort -n`)
  ( echo ${tmp}.0/$rp $offset 0 ; \
    echo ${tmp}.1 0 0 ; \
    echo ${tmp}.2 `expr $rp - $i` 0 ) | paste_gray 255 ${tmp}.0/$rp
end
rm ${tmp}.[1-2]
#
t2g_movie_gray ${tmp}.0 --n $argv[6] ; rm -r ${tmp}.0
