
#include "rr2dpc.h"

#define DIFF(sign,I0,I)	((I>0.0)?(I-(I0))*sign:0.0)

static double	Mean(unsigned x1,unsigned x2,FOM *fom)
{
	unsigned	x;
	double		sum=0.0;

	for (x=x1; x<x2; x++) if (fom[x]>0.0) sum+=fom[x];

	return sum/(double)(x2-x1);
}

void	RR2DPC(int Nx,int Ny,FOM **fom,unsigned l,unsigned r,double sign)
{
	int	y,x;
	double	m,mL,mR,xL,xR,xRL,mRL;

	if (l==0 && r==0)
	    for (y=0; y<Ny; y++)
	    for (x=0; x<Nx; x++) fom[y][x]*=sign;
	else
	    if ((unsigned long long)l+(unsigned long long)r>=Nx)
		for (y=0; y<Ny; y++)
		    if ((m=Mean(0,Nx,fom[y]))>0.0)
			for (x=0; x<Nx; x++) fom[y][x]=DIFF(sign,m,fom[y][x]);
		    else
			for (x=0; x<Nx; x++) fom[y][x]=0.0;
	    else
		for (y=0; y<Ny; y++) {
		    mL=Mean(0,l,fom[y]);
		    mR=Mean(Nx-r,Nx,fom[y]);
		    if (mL>0.0 && mR>0.0) {
/*
			m[x]=mL+(mR-mL)*(x-xL)/(xR-xL)
			    =(mL*(xR-x)+mR*(x-xL))/(xR-xL)
			    =(mL*xR-mR*xL+(mR-mL)*x)/(xR-xL)
*/
			xL=(double)(l-1)/2.0;
			xR=(double)Nx-(double)(r+1)/2.0;
			xRL=xR-xL; mRL=(mR/=xRL)-(mL/=xRL);
			for (m=mL*xR-mR*xL, x=0; x<Nx; x++, m+=mRL)
			    fom[y][x]=(m>0.0)?DIFF(sign,m,fom[y][x]):0.0;
		    }
		    else if (mL>0.0)
			for (x=0; x<Nx; x++) fom[y][x]=DIFF(sign,mL,fom[y][x]);
		    else if (mR>0.0)
			for (x=0; x<Nx; x++) fom[y][x]=DIFF(sign,mR,fom[y][x]);
		    else
			for (x=0; x<Nx; x++) fom[y][x]=0.0;
		}
}
