
#include <stdio.h>
#include "sif_r.h"

#ifdef	INT_BPS
#include "cell.h"
#include "sif.h"
#else
#include "sif_f.h"
#endif

#define LEN	2048

void	StoreImageFile_Raw(char *path,int Nx,int Ny,
			   double min,double max,FOM **fom)
{
	char	range[LEN];

	(void)sprintf(range,"%lf\t%lf",min,max);
#ifdef	INT_BPS
{
	int	y,x;
	Cell	*cell,C=(Cell)((1ULL<<INT_BPS)-1);
	double	base=min,step=(min>=max)?1.0:(max-min)/(double)C;

	for (y=0; y<Ny; y++) {
	    cell=(Cell *)fom[y];
	    for (x=0; x<Nx; x++)
		cell[x]=(fom[y][x]<min)?0:
			(fom[y][x]>max)?C:(Cell)((fom[y][x]-base)/step+0.5);
	}
}
	StoreImageFile(path,Nx,Ny,INT_BPS,(Cell **)fom,range);
#else
	StoreImageFile_Float(path,Nx,Ny,fom,range);
#endif
}
