#!/bin/csh
# usage : test_a.csh RI/ nameFile VLR_file layer Dr Or1 Or2 Test_A/
# usage : test_p.csh RR/ nameFile VLR_file layer SDD Dp Or1 Or2 Test_P/
#
#set sg_raw=sg_B
set sg_raw=sg_W
#set sg_raw=sg_F
#set sg_raw=sg_D
#
#@ tg_bps = 8
@ tg_bps = 16
#
set sg2tgs=sg2tgs	# CBP by both CUDA and single thread
#set sg2tgs=sg2tgs_wai	# CUDA with angular interpolation
#set sg2tgs=sg2tgs_nai	# single thread without angular interpolation
#set sg2tgs=sg2tgs_int	# single thread with BP by integer arithmetic
#set sg2tgs=sg2tgs_t	# multi-thread CBP
#set sg2tgs=sg2tgs_tnai	# multi-thread without angular interpolation
#set sg2tgs=sg2tgs_tint	# multi-thread with BP by integer arithmetic
#
setenv CUDA_GPU 0	# device number of CUDA-GPU
#setenv CBP_THREADS 4	# number of threads
#
#set tmp=/tmp/test.$$
set tmp=/dev/shm/test.$$
#
alias STDERR 'echo echo 1\>\&2 "\!*" | /bin/sh'
#
set csh=`basename $0`
switch($csh)
  case test_a.csh :
    set arg=(RI/ nameFile VLR_file layer Dr Or1 Or2 Test_A/)
    set arg_or=6-7
    alias RAW2SG 'ri2$sg_raw $argv[1-3] \!:1 \!:1 \!:2 > /dev/null'
    alias SG2TGS '$sg2tgs \!:1 $argv[5] \!:2-5 > \!:6'
    breaksw
  case test_p.csh :
    set arg=(RR/ nameFile VLR_file layer SDD Dp Or1 Or2 Test_P/)
    set arg_or=7-8
    alias RAW2SG 'rr2$sg_raw $argv[1-3] \!:1 \!:1 $argv[5-6] 1 \!:2 > /dev/null'
    alias SG2TGS '$sg2tgs \!:1 1 \!:2-5 > \!:6'
    breaksw
  default :
    STDERR $csh : unknown C-shell script. ; exit 1
endsw
#
if ($#argv != $#arg) then
  STDERR usage : $csh $arg ; exit 1
endif
#
set test=$argv[$#argv]
if (!(-d $test)) then
  STDERR $test : directory not found. ; exit 1
endif
#
set or=($argv[$arg_or])
set do=(`echo $or | awk '$1<=$2 { print -$1,-0.5,int(($2-$1)/0.5)+1 }'`)
if ($#do != 3) then
  STDERR $or : bad range of rotation center. ; exit 1
endif
#
set layer=$argv[4]
#
RAW2SG $layer ${test}/${layer}.tif ; if ($status) exit 1
#
raw2bin $test -${layer}.tif ${tmp}.bin
if ($status) then
  rm -f ${tmp}.bin ; exit 1
endif
#
mkdir ${tmp}.dir
SG2TGS ${tmp}.bin $do 0 $tg_bps ${tmp}.dir ${tmp}.log
if ($status) then
  rm -rf ${tmp}.* ; exit 1
endif
#
ls ${tmp}.dir | xargs -i@ mv -f ${tmp}.dir/@ ${test}/${layer}_@
sed s/\^-/${layer}\\t/g ${tmp}.log
rm -rf ${tmp}.*
