
#include <stdio.h>
#include <stdlib.h>
#include "sif_f.h"

extern void	Error(char *);

#define LEN	2048

int	main(int argc,char **argv)
{
	FILE	*file;
	char	str[LEN];
	int	X,Y,y,z,x,Z=1;
	FOM	**fom;
	double	pv,min,max;

	if (argc!=3) Error("usage : txt2t_f image.txt TIFF_format");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fgets(str,LEN,file)==NULL ||
	    sscanf(str,"%d %d %d",&X,&Y,&Z)<2 ||
	    X<=0 || Y<=0 || Z<=0) Error("bad image size.");

	if ((fom=(FOM **)malloc(sizeof(FOM *)*Y))==NULL ||
	    (*fom=(FOM *)malloc(sizeof(FOM)*Y*X))==NULL)
	    Error("memory allocation error.");

	for (y=1; y<Y; y++) fom[y]=fom[y-1]+X;

	for (z=0; z<Z; z++) {
	    for (y=0; y<Y; y++)
	    for (x=0; x<X; x++)
		if (fscanf(file,"%lf",&pv)==1)
		    fom[y][x]=pv;
		else
		    Error("data read error");

	    (void)sprintf(str,argv[2],z);
	    StoreImageFile_Float(str,X,Y,fom,SIF_F_desc);

	    if (z==0) {
		min=SIF_F_min;
		max=SIF_F_max;
	    }
	    else {
		if (min>SIF_F_min) min=SIF_F_min;
		if (max<SIF_F_max) max=SIF_F_max;
	    }
	}
	(void)printf("%lf\t%lf\n",min,max);

	if (file!=stdin) (void)fclose(file);

	free(*fom); free(fom);

	return 0;
}
