
#include <stdio.h>
#include <stdlib.h>
#include "vlr.h"

static void	Error(char *head,char *tail)
{
	(void)fputs(head,stderr); (void)fputs(" : ",stderr);
	(void)fputs(tail,stderr); (void)fputs(".\n",stderr); exit(1);
}

#define LEN	2048

VLR	*ViewRangeListWithLeftAndRightMargin(int views,char *path)
{
	VLR	*vlr;
	size_t	v,V=views-1;
	FILE	*file;
	char	str[LEN],RL[LEN];
	int	n,l,r;

	if ((vlr=(VLR *)malloc(sizeof(VLR)*views))==NULL)
	    Error(path,"no allocatable memory for structure VLR.");

	for (v=0; v<=V; v++) vlr[v].view=0;

	if (path[0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(path,"r"))==NULL) Error(path,"file not found");

	while (fgets(str,LEN,file)!=NULL)
	    if ((n=sscanf(str,"%s %d %d",RL,&l,&r))==1 || n==3)
{
	char	*rl=RL,*brl="bad range list.";
	int	c;
	size_t	v1,v2;
	    
#define RL2C(c)	(c=(*(rl++)))
#define RL2V(v)	\
	for (v=0; c>='0' && c<='9'; RL2C(c)) if ((v=v*10+c-'0')>V) Error(RL,brl)

	do {
	    while (RL2C(c)==',') ;

	    if (c!='\0') {
		if (c=='-') {
		    v1=0;
		    if (RL2C(c)==',' || c=='\0')
			v2=V;
		    else if (c=='$') {
			v2=V; if (RL2C(c)!=',' && c!='\0') Error(RL,brl);
		    }
		    else {
			RL2V(v2);
			if (c!=',' && c!='\0') Error(RL,brl);
		    }
		}
		else if (c=='$') {
		    v1=v2=V; if (RL2C(c)!=',' && c!='\0') Error(RL,brl);
		}
		else {
		    RL2V(v1);
		    if (c==',' || c=='\0')
			v2=v1;
		    else if (c=='-')
			if (RL2C(c)==',' || c=='\0')
			    v2=V;
			else if (c=='$') {
			    v2=V; if (RL2C(c)!=',' && c!='\0') Error(RL,brl);
			}
			else {
			    RL2V(v2);
			    if ((c!=',' && c!='\0') || v2<v1) Error(RL,brl);
			}
		    else
			Error(RL,brl);
		}
		if (n==1)
		    for (v=v1; v<=v2; v++) vlr[v].view=0;
		else
		    for (v=v1; v<=v2; v++) {
			vlr[v].view=1; vlr[v].left =(unsigned)l;
				       vlr[v].right=(unsigned)r;
		    }
	    }
	} while (c==',');
}
	if (file!=stdin) (void)fclose(file);

	return vlr;
}
