
#include <stdio.h>
#include <stdlib.h>
#include "csi_f.h"
#include "rif_r.h"
#include "sif_r.h"

extern void	Error(char *msg);

#define LEN	2048

int	main(int argc,char **argv)
{
	char	**paths,path[LEN];
	int	Nz,z,name,Nx,Ny,X,y,x;
	double	last,d,min,max,Dr=2.0;
	FOM	**F,*f;

	if (argc!=4 && argc!=5) Error("usage : xp2dpc XP/ nameFile {Dr} DPC/");

	paths=CheckSliceImages_Float(argv[1],argv[2],NULL,NULL,&Nz,NULL);

	if (argc==5 && (Dr=atof(argv[3])*2.0)<=0.0)
	    Error("bad interval of detectors.");

	name=0; while (argv[1][name++]!='\0') ;

	for (z=0; z<Nz; z++) {
	    ReadImageFile_Raw(paths[z],&Nx,&Ny,&F);

	    X=Nx-1;
	    for (y=0; y<Ny; y++) {
		last=0.0; f=F[y];
		for (x=0; x<Nx; x++) {
		    d=(((x==X)?0.0:f[1])-last)/Dr; last=f[0]; *(f++)=d;

		    if (x==0 && y==0) min=max=d; else if (min>d) min=d;
						 else if (max<d) max=d;
		}
	    }
	    (void)printf("%d\t%lf\t%lf\n",z,min,max);

	    (void)sprintf(path,"%s/%s",argv[argc-1],paths[z]+name);
	    StoreImageFile_Raw(path,Nx,Ny,min,max,F);

	    for (y=Ny-1; y>=0; y--) free(F[y]); free(F); free(paths[z]);
	}
	free(paths);

	return 0;
}
